/*****************************************************************************
 * Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
 *
 *    NAME: b15_process_pos_initial_crd4.sas
 *
 * PURPOSE: Prepare for enriching positions.
 *
 *   USAGE: 
 *
 *   NOTES:  
 *          
 *
 *         
 *          
 *          
 *
 *****************************************************************************/

%macro b15_process_pos_initial_crd4;

%global ISSUE_CPTY_EXIST;
/*- Create issue rating tables -*/

/*- RD_STAGE.issue_ratings needs to be pre-sorted on ISSUE_KEY -*/
%create_issue_rating_crd4(rating_time= CURRENT); 
%create_issue_rating_crd4(rating_time= INCEPTION);  

/*- create the invalid approach data structure -*/
data RD_POS.invalid_approach;
length INSTID COUNTERPARTY_CLASS STD_PRODUCT_CLASS STD_PRODUCT_SUBCLASS IRB_PRODUCT_CLASS IRB_PRODUCT_SUBCLASS
       APPROACH_CLASS $32. APPROACH $16.;
stop;
run;

/*- create the invalid risk component data structure -*/
data RD_POS.all_exp_with_invalid_components;
length LOCATION REASON CPTY_PD_MODEL_ID PD_MODEL_ID LGD_MODEL_ID $32.
       PD_MODEL_RATING_GRADE  LGD_MODEL_RATING_GRADE CPTY_PD_RATING_GRADE $20.;
length PD_PCT LGD_PCT CPTY_PD_PCT 8.;
length ORIGINAL_APPROACH APPROACH $16.;
length INSTID $20.;

stop;
run;
%mend b15_process_pos_initial_crd4;
