/*****************************************************************************
* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME: b20_prep_regrpt_port_crgb3_crd4.sas
*
* PURPOSE: Create portoflio data for CR GB 3 report
*
*   USAGE:
*
*   NOTES:
*
*****************************************************************************/
 
 
%macro b20_prep_regrpt_port_crgb3_crd4;
%macro prepare_regrpt_port_gb3 (inputds);


/*---------------------------------------------------------------------------
* Step 1. Check to see if the user has requested the report 
* -------------------------------------------------------------------------*/
 
 %let HAVEDATA=NO;
  
 %if  
      (%UPCASE(&REGPROJECTNAME) EQ CAPITAL_CRGB_3_CRD4 ) OR
      (%UPCASE(&REGPROJECTNAME) EQ ALL) 
 
 %then %do;
  
         %if %UPCASE(&MITIGANTS_ALLOCATION_METHOD) EQ OPTIMAL
         %then %do;

         libname _incrlib  "&REGPATH";
         %goto checkirba_opt;
  
 %end;
  
 %else %if %UPCASE(&MITIGANTS_ALLOCATION_METHOD) EQ BY_RANK          
 %then %do;
  
         libname _incrlib  "!CRISKMRES&PATHSEP.&PROJECT_SET&PATHSEP.&PROJECT_SET._rnk";
         %goto checkirba_rnk;
  
 %end;
  
 %end;
     
 %else %goto SKIP;

 
 
/*---------------------------------------------------------------------------
* Step 2. Check to see if we have data
* -------------------------------------------------------------------------*/

%SKIP:
%print_msg (NOTE,3,60);/*-------------------------->Add another message*/
%return;

 
%CHECKIRBA_OPT:
%checkdata (_incrlib, &INPUTDS , );

%CHECKIRBA_RNK:
%checkdata (_incrlib, &INPUTDS , );

 
/* If no data then return*/
%if   (&HAVEDATA = NO)  %then %do;
%print_msg (WARNING,3,1);/*------------------------>Change this message*/
%return;
%end;

/*---------------------------------------------------------------------------
* Step 3a. Creating portfolio for LR2 report
* -------------------------------------------------------------------------*/

%print_msg(note,3,26);
%if &APPLY_CCF_AFTER_CRM EQ NO %then %print_msg (warning,3,108);


data _intds.CAPITAL_CRGB_3_CRD4;
    length INTERNAL_ORG_RK $25.;
    set _incrlib.&INPUTDS(rename=(INTERNAL_ORG_RK=INT_ORG_RK));

    INTERNAL_ORG_RK = put(INT_ORG_RK, MAP_INTERNAL_ORG_RK_CARPT.);   
    INSTTYPE = 'regrpt_gb3';
    INSTID = EXP_ID;
    CAPITAL = RWA * &CAPITAL_RATIO;
run;


/*---------------------------------------------------------------------------
* Step 4. Check to see if data was created
* -------------------------------------------------------------------------*/

%checkdata (_intds,CAPITAL_CRGB_3_CRD4,   );

%if &HAVEDATA = YES %then
%do;
%status(CAPITAL_CRGB_3_CRD4,SUCCESS,CR GB 3,CAPITAL_CRGB_3_CRD4);
%end;
%else
%do;
%print_msg (WARNING,3,62);
%status(CAPITAL_CRGB_3_CRD4,Problems creating input data for portfolio,CAPITAL_CRGB_3_CRD4);

%end;


%mend prepare_regrpt_port_gb3;

%prepare_regrpt_port_gb3 (crm_allocation_&MITIGANTS_ALLOCATION_METHOD._detail);
options notes source;

%mend b20_prep_regrpt_port_crgb3_crd4;
