



/*****************************************************************************
* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME: c10_def_regrpt_output_var_crd4.sas
*
* PURPOSE: Define additional output variables for regulatory reporting
*
*   USAGE:
*
*   NOTES:
*
*
*****************************************************************************/
 
%macro c10_def_regrpt_output_var_crd4;

proc risk noseqcheck ;
 
environment open = RD_PROJ.REGRPT;
 
declare outvars = (
OUTV_EXP_PRE_CCF_PRE_CRM       num computed,
OUTV_CAPITAL                   num computed,
OUTV_CLLTRL_OTHER_PHYSICAL_AMT num computed,
OUTV_CLLTRL_REAL_ESTATE_AMT    num computed,
OUTV_CLLTRL_RECEIVABLE_AMT     num computed,
OUTV_CREDIT_DERIV_UNFUNDED_AMT num computed,
OUTV_CREDIT_PROTECT_FUNDED_AMT num computed,
OUTV_CREDIT_PROTECT_UNFUND_AMT num computed,
OUTV_EAD_OB                    num computed,
OUTV_EAD_LOOKTHROUGH_AMT       num computed,
OUTV_ELIG_FIN_COLLATERAL_AMT   num computed,
OUTV_EXPOSURE_ADJ_AMT          num computed,
OUTV_EXPOSURE_NET_AMT          num computed,
OUTV_EXPOSURE_ORIG_AMT         num computed,
OUTV_FIN_COLL_ADJ_VAL_AMT      num computed,
OUTV_GUARANTEE_UNFUNDED_AMT    num computed,
OUTV_INFLOW_IRB_AMT            num computed,
OUTV_INFLOW_WITHIN_SA_AMT      num computed,
OUTV_OUTFLOW_IRB_AMT           num computed,
OUTV_OUTFLOW_WITHIN_SA_AMT     num computed,
OUTV_RWA                       num computed,
RWA_PRE_SME_AMT				   num computed,
OUTV_SEC_FUNDED_AMT            num computed,
OUTV_SEC_UNFUNDED_AMT          num computed,
OUTV_TRANCHE_NOMINAL_AMT       num computed,
OUTV_VALUE_ADJ_AMT             num computed,
OUTV_VOL_ADJ_EXP_AMT           num computed,
OUTV_VOL_MAT_ADJ_AMT           num computed,
_INFLOW_IRB_AMT_OB_            num computed,
_OUTFLOW_IRB_AMT_OB_           num computed,
_EXP_PRE_CCF_PRE_CRM_OB_       num computed,
OUTV_EXP_PRE_CCF_AFTER_CRM     num computed,
OUTV_EXP_PRE_CCF_AFTER_CRM_OB  num computed postvar,
OUTV_FULLY_ADJ_EXP_AMT         num computed,
OUTV_CCF1                      num computed,
OUTV_CCF2                      num computed,
OUTV_CCF3                      num computed,
OUTV_CCF4                      num computed,
OUTV_CCF5                      num computed,
OUTV_EAD_ROLLUP                num computed,
OUTV_DED_OWN_FUNDS             num computed,
OUTV_EAD_IAA                   num computed,
OUTV_EAD_RW_10                 num computed,
OUTV_EAD_RW_18                 num computed,     
OUTV_EAD_RW_20                 num computed,
OUTV_EAD_RW_35                 num computed,
OUTV_EAD_RW_50                 num computed,  
OUTV_EAD_RW_75                 num computed,
OUTV_EAD_RW_100                num computed,
OUTV_EAD_RW_250                num computed,
OUTV_EAD_RW_350                num computed,
OUTV_EAD_RW_425                num computed,
OUTV_EAD_RW_650                num computed,
OUTV_EAD_RW_1250_RATED         num computed,
OUTV_EAD_RW_1250_UNRATED       num computed,
OUTV_EAD_SFA                   num computed,
OUTV_EXP_ADJ_CCF_0             num computed,
OUTV_EXP_ADJ_CCF_0_20          num computed,
OUTV_EXP_ADJ_CCF_20_50         num computed,
OUTV_EXP_ADJ_CCF_50_100        num computed,
OUTV_RETAINED_AMT              num computed,
OUTV_RW_IAA                    num computed postvar,
OUTV_RW_SFA                    num computed postvar,
OUTV_SEC_FUNDED_UND_AMT        num computed,
OUTV_SEC_UNFUNDED_UND_AMT      num computed,
OUTV_SUB_RW                    num computed,
OUTV_PRE_CCF_AFTER_CRM         num computed,
OUTV_EAD_LOOK_THROUGH_2ND_LOSS num computed,
OUTV_EAD_CCR                   num computed,
OUTV_EAD_LGD65_AMT             num computed,
OUTV_EAD_LGD90_AMT             num computed,
OUTV_RW_ECAI_AMT                   num computed,
OUTV_RW_GOVT_AMT                   num computed,
OUTV_EAD_FUND_CCP_AMT              num computed,
/*Defined for IRB template */ 
OUTV_LARGE_FIN_ORG_EXP_AMT  num computed,
OUTV_LARGE_FIN_EXPOSURE_VAL_AMT     num computed,
OUTV_EXP_OF_WHICH_CCR               num computed,
OUTV_WA_LGD_LARGE_FIN_AMT               num computed ROLLUP=VALWGT, 
OUTV_RWA_LARGE_FIN_ENTITY_AMT       num computed,
OUTV_CRD_DERIV_UNFUND_LGD               num computed,
OUTV_FUND_CRED_PROTECT_LGD              num computed,               
OUTV_GUAR_UNFUND_LGD                    num computed,               
OUTV_GUAR_UNFUND_NLGD                   num computed,         
OUTV_CRD_DERIV_UNFUND_NLGD              num computed,           
OUTV_FUND_CRED_PROTECT_NLGD             num computed,
OUTV_UNFUND_CRED_PROTECT_LGD_DD     num computed,
OUTV_OFF_BAL_EXP_PRE_CCF_CRM            num computed,
OUTV_OFF_BAL_EAD                        num computed,
/*Defined for CR GB Template*/
OUTV_PROVISIONS_NEW_DFLT_AMT       num computed,
OUTV_NEW_DEFAULTS_AMT              num computed,
OUTV_DEFAULTS_AMT              num computed,
OUTV_RWA_DEFAULT_AMT           num computed,
OUTV_LGD_EFF_DEFAULT_PCT       num computed ROLLUP=VALWGT, 
OUTV_SPECIFIC_WRITEOFF_AMT         num computed,

/*Defined for LE reports*/
OUTV_DIR_EXP_DEBT_AMT  num computed,
OUTV_DIR_EXP_EQUITY_AMT num computed,
OUTV_DIR_EXP_DERIVATIVE_AMT num computed,
OUTV_DIR_EXP_OBSI_LOAN_AMT num computed,
OUTV_DIR_EXP_OBSI_GUAR_AMT num computed,
OUTV_DIR_EXP_OBSI_OTH_AMT num computed,
OUTV_INDIR_EXP_DEBT_AMT num computed,
OUTV_INDIR_EXP_EQUITY_AMT num computed,
OUTV_INDIR_EXP_DERIVATIVE_AMT num computed,
OUTV_INDIR_EXP_OBSI_LOAN_AMT num computed,
OUTV_INDIR_EXP_OBSI_GUAR_AMT num computed,
OUTV_INDIR_EXP_OBSI_OTH_AMT num computed,
OUTV_UNDERLYING_EXP_EAD_AMT num computed,
OUTV_TOT_ORIG_EXP_AMT num computed,
OUTV_TOT_ORIG_EXP_DEFLT_AMT num computed,
OUTV_CRM_EXP_EQUITY_AMT num computed,
OUTV_CRM_EXP_DEBT_AMT num computed,
OUTV_CRM_EXP_DERIVATIVE_AMT num computed,
OUTV_CRM_EXP_OBSI_LOAN_AMT num computed,
OUTV_CRM_EXP_OBSI_GUAR_AMT num computed,
OUTV_CRM_EXP_OBSI_OTHER_AMT num computed,
OUTV_CR_PRTCTN_NOT_SUB_EFF_AMT num computed,
OUTV_ELIG_CRM_REAL_ESTATE_AMT num computed,
OUTV_LE_EXEMPTED_AMT num computed,
OUTV_EXP_PRE_CRM_AMT num computed,
OUTV_EXP_PRE_CRM_TB_AMT num computed,
OUTV_EXP_POST_CRM_AMT num computed,
OUTV_EXP_PRE_CRM_PCT num computed,
OUTV_EXP_POST_CRM_TB_AMT num computed,
OUTV_EXP_POST_CRM_PCT num computed,
OUTV_CAP_REQM_LRG_EXP_TB_AMT num computed,
/*Le 4 5 outvar*/
MATURITY_EXP num computed,
/*CVA OUTPUP VARS*/
OUTV_CVA_EAD_AMT              num computed,
OUTV_CVA_DERIVATIVES_AMT      num computed,
OUTV_CVA_SFT_AMT              num computed,
OUTV_CVA_CHARGE_AMT           num computed,
OUTV_CVA_TOTAL_RISK_EXP_AMT      num computed,
OUTV_CVA_CPTY_NO                 num computed,
OUTV_NAME_CDS_AMT             num computed,
OUTV_INDEX_CDS_AMT            num computed,
/*OUTV_CPTY_NAME num computed,*/
/*OUTV_CPTY_CODE num computed,*/
/*OUTV_LEI_CODE num computed,*/
/*OUTV_CPTY_RESI num computed,*/
/*OUTV_CPTY_SECTOR num computed,*/
/*OUTV_NACE num computed,*/
/*OUTV_CPTY_TYPE num computed*/

/*LR output vars*/ 
OUTV_EAD_IRB_AMT      num computed,
OUTV_RWA_IRB_AMT      num computed,
OUTV_EAD_STD_AMT      num computed,
OUTV_RWA_STD_AMT      num computed,
OUTV_EAD          num computed,

/* SEC-SA new variables */
EAD_SEC_IAA_AMT 		num computed,
RWA_SYNTHETIC_SEC_AMT 		num computed,
RWA_ADJ_INFRINGEMENT_AMT 	num computed,
RWA_ADJ_MATURITY_MISMATCH_AMT 	num computed,
RWA_BEFORE_CAP_AMT 		num computed,
RWA_AFTER_CAP_AMT 		num computed,
TOTAL_OUTFLOW_CRM_SUB_AMT 	num computed,
TOTAL_INFLOW_CRM_SUB_AMT 	num computed,
RWA_SEC_OUTFLOW_OTHER_EXP_AMT 		num computed,
EAD_IAA_AVG_RW_PCT		num computed,
EAD_LOOK_THRU_AVG_RW_PCT num computed,
EAD_LOOK_THRU_NUMERATOR_AMT  num computed,
EAD_IAA_NUMERATOR_AMT num computed,

/*- SEC Details variables -*/
SEC_RETENTION_PCT              NUM      COMPUTED,
NON_ABCP_ORIGINATION_DT        NUM      COMPUTED,
NON_ABCP_ORIG_AMT              NUM      COMPUTED,
TOTAL_AMT                      NUM      COMPUTED,
INSTITUTION_SHARE_PCT          NUM      COMPUTED,
EFFECTIVE_EXPOSURE_NO          NUM      COMPUTED,
ELGD_PCT                       NUM      COMPUTED,
VALUE_ADJUST_PROVISIONS_AMT    NUM      COMPUTED,
OWN_FUND_REQ_PRE_SEC_AMT       NUM      COMPUTED,
ON_BS_SEN_TRANCHE_VALUE_AMT    NUM      COMPUTED,
ON_BS_MEZZ_TRANCHE_VALUE_AMT   NUM      COMPUTED,
ON_BS_FL_TRANCHE_VALUE_AMT     NUM      COMPUTED,
FIRST_TERM_DT                  NUM      COMPUTED,
LEGAL_FINAL_DT                 NUM      COMPUTED,
OFF_BS_SEN_TRANCHE_VALUE_AMT   NUM      COMPUTED,
OFF_BS_MEZZ_TRANCHE_VALUE_AMT  NUM      COMPUTED,
OFF_BS_FL_TRANCHE_VALUE_AMT    NUM      COMPUTED,
ON_BS_SEN_EXP_VALUE_AMT        NUM      COMPUTED,
ON_BS_MEZZ_EXP_VALUE_AMT       NUM      COMPUTED,
ON_BS_FL_EXP_VALUE_AMT         NUM      COMPUTED,
OFF_BS_SEN_EXP_VALUE_AMT       NUM      COMPUTED,
OFF_BS_MEZZ_EXP_VALUE_AMT      NUM      COMPUTED,
OFF_BS_FL_EXP_VALUE_AMT        NUM      COMPUTED,
DCS_MEMO_AMT                   NUM      COMPUTED,
IRS_CRS_MEMO_AMT               NUM      COMPUTED,
FAC_MEMO_AMT                   NUM      COMPUTED,
OTHER_MEMO_AMT                 NUM      COMPUTED,
CCF_APPLIED_PCT                NUM      COMPUTED,
OWN_FUNDS_DEDUCTION_AMT        NUM      COMPUTED,
PRE_CAP_EXPOSURE_AMT           NUM      COMPUTED,
POST_CAP_EXPOSURE_AMT          NUM      COMPUTED,
LONG_POSITION_NET_AMT          NUM      COMPUTED,
SHORT_POSITION_NET_AMT         NUM      COMPUTED,
SPECIFIC_RISK_AMT              NUM      COMPUTED,
/* SEC- IRB new variables */
EAD_RW_7 num computed,
EAD_RW_8 num computed,
EAD_RW_12 num computed,
EAD_RW_20 num computed,
EAD_RW_60 num computed
); 
 
environment save noupdatemetadata;
run;
 
 
/*----------------------------------------------------------------- *
* Data driven registration of output variables for the CA template *
*----------------------------------------------------------------- */
 
/*- Part 1: Input variables that are included in output
To avoid conflicts in RD, these output
variables are named as _"INPUT NAME" e.g.
the input IA_CAPITAL_AMT will be included
in the output with the name _IA_CAPITAL_AMT -*/
data work.out_dummy;
length name $32.;
set work._fin_instr_ (keep = name);
if NAME EQ 'INTERNAL_ORG_RK' then delete;
NAME=trim('__')||trim(NAME);
run;
 
 
/* Part 2: Merge the above output variables with th ones
calculated from the system                   */
data work.carpt_output;
length name $64.;
set work.out_dummy
rd_root.capmethods_finfact (keep = name);
TYPE= 'NUM';
run;
 
 
proc sort data=work.carpt_output nodupkey;
by name;
run;
 
 
 
/* Data-driven registration of output variables */
%u00_recreate_macro_definitions;
%let valuetype = 1;
%readoutvars(env = RD_PROJ.REGRPT, data = work.carpt_output);
%u00_save_macro_definitions;
%mend c10_def_regrpt_output_var_crd4;
