/*****************************************************************************
* Copyright (c) 2014 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME: c20_def_regrpt_ccvars_crd4.sas
*
* PURPOSE: Define cross-classification hierarchies for regulatory reporting
*
*   USAGE:
*
*   NOTES:
*
*
*****************************************************************************/
 
%macro c20_def_regrpt_ccvars_crd4;

proc risk noseqcheck ;
 
environment open = RD_PROJ.REGRPT;
 
crossclass regrpt_crirb
(EXPOSURE_CLASS_LEVEL_1 * EXPOSURE_CLASS_LEVEL_2 * EXPOSURE_TYPE * CRM_GROUP * OBLIGOR_FLAG * OBLIGOR_GRADE *
OTHER_CR_CLASSES * SL_FLAG * SL_TYPE * SL_OF_WHICH_CAT1 * OWN_LGD_CCF_ESTIMATES * SME_SUPPORT_FACTOR);
 
crossclass regrpt_crsa
       (EXPOSURE_CLASS_LEVEL_1 * EXPOSURE_CLASS_SA_LEVEL_1 * EXPOSURE_TYPE * REGRPT_CCF_BUCKET * RW_GROUPS * 
       RW_SUB_GROUP * EXPOSURE_CLASS_LEVEL_2 * COLLATERAL_TYPE * SME_SUPPORT_FACTOR * COUNTERPARTY_TYPE * APPROACH_USAGE)
;

crossclass regrpt_crgb
       (COUNTERPARTY_COUNTRY * EXPOSURE_CLASS_LEVEL_1 * EXPOSURE_CLASS_SA_LEVEL_1 * EXPOSURE_CLASS_SA_LEVEL_2 * EXPOSURE_CLASS_LEVEL_2);

crossclass regrpt_gb3 (COUNTERPARTY_COUNTRY); 

crossclass regrpt_crgb_irb
       (COUNTERPARTY_COUNTRY * EXPOSURE_CLASS_IRB_LEVEL_1 * EXPOSURE_CLASS_LEVEL_1 * EXPOSURE_CLASS_LEVEL_2 * EXPOSURE_SUBTYPE);
       
crossclass regrpt_cr_equ 
        (APPROACH * OBLIGOR_GRADE * SIMPLE_RW_GROUP * COUNTERPARTY_COUNTRY);
 
 
crossclass regrpt_crsec_irb 
        (SEC_STRUCTURE_TYPE * PRIMARY_BANK_ROLE * EXPOSURE_TYPE * EXPOSURE_SUBTYPE * SENIORITY_STATUS * CQS_BUCKET * APPROACH * REGRPT_CCF_BUCKET * REGRPT_RW_BUCKET );



 
crossclass regrpt_crsec_sa
        (SEC_STRUCTURE_TYPE * PRIMARY_BANK_ROLE * EXPOSURE_TYPE * EXPOSURE_SUBTYPE * CQS_BUCKET * SENIORITY_STATUS * REGRPT_CCF_BUCKET * REGRPT_RW_BUCKET);
 
 
crossclass regrpt_ca (INTERNAL_ORG_RK);

crossclass report_capital_1 (EXPOSURE_CLASS_LEVEL_1 * EXPOSURE_CLASS_LEVEL_2 * EXPOSURE_TYPE * REGRPT_OBLIGOR_GRADE );

crossclass report_capital_2 (EXPOSURE_CLASS_LEVEL_1 * EXPOSURE_CLASS_LEVEL_2 * EXPOSURE_CLASS_LEVEL_3 * EXPOSURE_TYPE *
PAST_DUE_STATUS * RATING_STATUS * STD_PRODUCT_SUBCLASS * REGRPT_RW_BUCKET * REGRPT_CCF_BUCKET );

crossclass regrpt_le2 (COUNTERPARTY_GROUP LECPTYID);
crossclass regrpt_le3 ( COUNTERPARTY_GROUP * LECPTYID );
crossclass regrpt_le4 ( LECPTYID COUNTERPARTY_GROUP  MATURITY_DESCRIPTION );
crossclass regrpt_le5 ( LECPTYID MATURITY_DESCRIPTION );
crossclass regrpt_le_limits (INTERNAL_ORG_RK);

crossclass regrpt_lr2 ( LR_RW_BUCKET  ); 
crossclass regrpt_lr4 ( EXPOSURE_TYPE * LR_EXPOSURE_CLASS_LEV_1 * LR_EXPOSURE_CLASS_LEV_2 * LR_EXPOSURE_CLASS_LEV_3 * LR_EXPOSURE_CLASS_LEV_4 * LR_EXPOSURE_CLASS_LEV_5); 

crossclass regrpt_cva ( CVA_CALCULATION_METHOD_TYPE );

crossclass regrpt_sec_det (INTERNAL_CODE SECURITIZATION_ID ORIGINATOR_ID SECURITIZATION_TYPE ACCOUNTING_TREATMENT SOLVENCY_TREATMENT SECURITIZATION_RESEC RETENTION_TYPE
                           RETENTION_COMPLIANCE INSTITUTION_ROLE ASSET_LIABILITY_TYPE APPROACH_APPLIED COUNTRY CTP_NON_CTP);
environment save noupdatemetadata;
 
run;
%mend c20_def_regrpt_ccvars_crd4;
