/*****************************************************************************
 * Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
 *
 *    NAME: calc_std_rw_life_ins_crd4.sas
 *
 * PURPOSE: Method program code for life insurance policy pledged to instituion under STD approach.
 *
 *   USAGE: %calc_std_rw_life_ins_crd4;
 *
 *   NOTES: 7/30/2013 created for CRD-IV.
 *          
 *
 *****************************************************************************/

%macro calc_std_rw_life_ins_crd4;

/*- initialize outvars -*/
    %initialize_regulatory_outvars;

/*- Get weight for CVA standardized approach: Art. 384 -*/
    %get_cva_std_wgt_crd4 ; 
 
/*- by default, get the RW associated with the counterparty -*/
    OUTV_RW_COUNTERPARTY = STD_RW_CPTY; 
   
/*- get RW from counterparty rating of the company providing life insurance: CRR Article 232(3)  -*/ 
    OUTV_RW_ISSUE = STD_RW_LIFE_INS_REF.STD_RW_BUCKET_COUNTERPARTY; 
     
                
    _VALUE_ = CRM_VALUE ;  
    
%mend calc_std_rw_life_ins_crd4;    
