/*****************************************************************************
 * Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
 *
 *    NAME: calc_std_rw_retail_crd4.sas
 *
 * PURPOSE: Code to get risk weight for retail exposures under STD approach in CRD-IV.
 *                   
 *   USAGE: %calc_std_rw_retail_crd4.sas
 *
 *           
 *   NOTES: 
 *   5/28/2013: Created for crd4    
 *          
 *****************************************************************************/
%macro calc_std_rw_retail_crd4;

    /*- initialize outvars -*/
    %initialize_regulatory_outvars;

    /*- by default, get the RW associated with the counterparty -*/
    OUTV_RW_COUNTERPARTY = STD_RW_CPTY;
    
    /*- Under CRD, retail exposures are assigned a risk weight of  -*/
    /*- 75%, with no reference to rating -- CRR Article 123 -*/
    OUTV_RW_ISSUE = STD_RW_RETAIL ;
   
    _VALUE_ = EXP_VALUE ;

%mend calc_std_rw_retail_crd4;
