/*****************************************************************************
* Copyright (c) 2014 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME: create_lr4_types_crd4.sas
*
* PURPOSE: Define cross-classification hierarchies for regulatory reporting
*
*   USAGE: Used by LR4 Report extraction macro regrpt_d0_capital_cr4.
*
*   NOTES:
*
*
*****************************************************************************/
%macro create_lr4_types_crd4;

data _null_;
filename f1 temp;
file f1;
put "10   OFF_BALANCE  +              +                   +         +         +               ";
put "20   OFF_BALANCE  +              +                   +         TRADE_FIN +               ";
put "30   OFF_BALANCE  +              +                   +         TRADE_FIN EXP_CREDIT_INS  ";
put "40   NETTING      +              +                   +         +         +               ";
put "50   DERIVATIVES  +              +                   +         +         +               ";
put "60   REPOS        +              +                   +         +         +               ";
put "70   OTHER_TB     +              +                   +         +         +               ";
put "80   ON_BALANCE   COV_BOND       +                   +         +         +               ";
put "90   ON_BALANCE   SOVEREIGN      +                   +         +         +               ";
put "100  ON_BALANCE   SOVEREIGN      CENT_GOV_CENT_BANK  +         +         +               ";
put "110  ON_BALANCE   SOVEREIGN      REG_GOV             +         +         +               ";
put "120  ON_BALANCE   SOVEREIGN      MDB                 +         +         +               ";
put "130  ON_BALANCE   SOVEREIGN      PSE                 +         +         +               ";
put "140  ON_BALANCE   NON_SOVEREIGN  +                   +         +         +               ";
put "150  ON_BALANCE   NON_SOVEREIGN  REG_GOV             +         +         +               ";
put "160  ON_BALANCE   NON_SOVEREIGN  MDB                 +         +         +               ";
put "170  ON_BALANCE   NON_SOVEREIGN  PSE                 +         +         +               ";
put "180  ON_BALANCE   INSTITUTION    +                   +         +         +               ";
put "190  ON_BALANCE   MORTGAGE       +                   +         +         +               ";
put "200  ON_BALANCE   MORTGAGE       RRE                 +         +         +               ";
put "210  ON_BALANCE   RETAIL         +                   +         +         +               ";
put "220  ON_BALANCE   RETAIL         +                   SME       +         +               ";
put "230  ON_BALANCE   CORPORATE      +                   +         +         +               ";
put "240  ON_BALANCE   CORPORATE      FINANCIAL           +         +         +               ";
put "250  ON_BALANCE   CORPORATE      NONFINANCIAL        +         +         +               ";
put "260  ON_BALANCE   CORPORATE      NONFINANCIAL        SME       +         +               ";
put "270  ON_BALANCE   CORPORATE      NONFINANCIAL        NONSME    +         +               ";
put "280  ON_BALANCE   DEFAULTED      +                   +         +         +               ";
put "290  ON_BALANCE   OTHER_EXPOSURE +                   +         +         +               ";
put "300  ON_BALANCE   OTHER_EXPOSURE SECURITIZATION      +         +         +               ";
put "310  ON_BALANCE   +              +                   +         TRADE_FIN +               ";
put "320  ON_BALANCE   +              +                   +         TRADE_FIN EXP_CREDIT_INS  ";
run;

data _rowcond;
infile f1;
length rownum 3. &rptvar1$11. &rptvar2 $20. &rptvar3 $20. &rptvar4 $20. &rptvar5 $20. &rptvar6 $20.;
input   rownum 
        &rptvar1 $   
        &rptvar2 $   
        &rptvar3 $     
        &rptvar4 $    
        &rptvar5 $ 
        &rptvar6 $ ;
                
run;

%mend  create_lr4_types_crd4;
