%macro create_types_crd4;
data _null_;
filename f1 temp;
file f1;
put "+";
/*From the Annexure-2 Instructions, for SR SEC SA Template: 
1.	The CR SEC SA template gathers joint information on both traditional and synthetic securitisations held in the banking book, as defined in Article 242 (10) and (11) of CRR, respectively.
*/
/*put "TRADITIONAL";
put "SYNTHETIC";*/ 
run;

data _types_sec1;
  infile f1;
  length &&rptvar1 $32.;
        input &&rptvar1 $;
run;


data _null_;
filename f1 temp;
file f1;
put "10    +           +           +                +        ";
put "20    +           +           RESECURITIZATION +        ";
put "30    ORIGINATOR  +           +                +        ";
put "40    ORIGINATOR  ON_BALANCE  +                +        ";
put "50    ORIGINATOR  ON_BALANCE  SECURITIZATION   +        ";
put "60    ORIGINATOR  ON_BALANCE  RESECURITIZATION +        ";
put "70    ORIGINATOR  OFF_BALANCE +                +        ";
put "80    ORIGINATOR  OFF_BALANCE SECURITIZATION   +        ";
put "90    ORIGINATOR  OFF_BALANCE RESECURITIZATION +        ";
put "100   ORIGINATOR  EARLY_AMT   +                +        ";
put "110   INVESTOR    +           +                +        ";
put "120   INVESTOR    ON_BALANCE  +                +        ";
put "130   INVESTOR    ON_BALANCE  SECURITIZATION   +        ";
put "140   INVESTOR    ON_BALANCE  RESECURITIZATION +        ";
put "150   INVESTOR    OFF_BALANCE +                +        ";
put "160   INVESTOR    OFF_BALANCE SECURITIZATION   +        ";
put "170   INVESTOR    OFF_BALANCE RESECURITIZATION +        ";
put "180   SPONSOR     +           +                +        ";
put "190   SPONSOR     ON_BALANCE  +                +        ";
put "200   SPONSOR     ON_BALANCE  SECURITIZATION   +        ";
put "210   SPONSOR     ON_BALANCE  RESECURITIZATION +        ";
put "220   SPONSOR     OFF_BALANCE +                +        ";
put "230   SPONSOR     OFF_BALANCE SECURITIZATION   +        ";
put "240   SPONSOR     OFF_BALANCE RESECURITIZATION +        ";
put "250   +           +           +                CQS1     ";
put "260   +           +           +                CQS2     ";
put "270   +           +           +                CQS3     ";
put "280   +           +           +                CQS4     ";
put "290   +           +           +                OTHER";

run;
data _rowcond;
infile f1;
length rownum 3. &&rptvar2 $11. &&rptvar3 $12. &&rptvar4 $16. &&rptvar5 $9.;
input   rownum 
        &&rptvar2 $   
        &&rptvar3 $     
        &&rptvar4 $    
        &&rptvar5 $ ;
                
run;

%mend create_types_crd4;
