/*****************************************************************************
* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME: d00_pm_regrpt_rollup_crd4.sas
*
* PURPOSE: Define methods for rollup calculations.
*
*   USAGE:
*
*   NOTES:
*
*
*****************************************************************************/
 
%macro d00_pm_regrpt_rollup_crd4;

proc compile outlib  = RD_PROJ.REGRPT
inlib   = RD_PROJ.REGRPT
package = pricing
env     = RD_PROJ.REGRPT
label   = 'Pricing Functions/Methods';
 

method PVM_CRIRB_ROLLUP kind=postvar label="PostVaR Method for CR IRB Rollup";
/*** condition to avoid division by zero error ***/ 
if  _value_.VALUE=. or _value_.VALUE=0 then do;
     OUTV_RW =.;
end;
else do;
     OUTV_RW = OUTV_RWA.VALUE / _value_.VALUE * 100;
end;


                                
endmethod;
 

method PVM_CR_EQU_ROLLUP kind=postvar label="PostVaR Method for CR EQU Rollup";
 /*** condition to avoid division by zero error ***/
if  _value_.VALUE=. or _value_.VALUE=0 then do;
     OUTV_RW =.;
end;
else do;
     OUTV_RW = OUTV_RWA.VALUE / _value_.VALUE * 100;
end;


OUTV_EXP_PRE_CCF_AFTER_CRM_OB = sum(_EXP_PRE_CCF_PRE_CRM_OB_.VALUE, _OUTFLOW_IRB_AMT_OB_.VALUE, _INFLOW_IRB_AMT_OB_.VALUE);
endmethod;
 
 

method PVM_CRSEC_IRB_ROLLUP kind=postvar label="PostVaR Method for CR SEC Rollup";
 
if upcase(APPROACH) = 'IRB_SFA' then OUTV_RW_SFA = OUTV_RWA.VALUE / _value_.VALUE * 100; /* Col 31 */
if upcase(APPROACH) = 'IRB_IAA' then OUTV_RW_IAA = OUTV_RWA.VALUE / _value_.VALUE * 100; /* Col 34 */
endmethod;
 
 
 
method PVM_CRSA_ROLLUP kind=postvar label="PostVaR Method for CR SA Rollup";
/*** condition to avoid division by zero error ***/
if  _value_.VALUE=. or _value_.VALUE=0 then do;
     OUTV_RW =.;
end;
else do;
     OUTV_RW = OUTV_RWA.VALUE / _value_.VALUE * 100;
end;

endmethod;
 
run;

%mend d00_pm_regrpt_rollup_crd4;
