/*****************************************************************************
* Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME: e10_prj_regrpt_cap_crgb_sa_crd4.sas
*
* PURPOSE: Run CR regulatory reports for Geographical breakdown of exposures by residence of the obligor subject to SA approach
*
*   USAGE:
*
*   NOTES:
*
*
*****************************************************************************/
 
%macro e10_prj_regrpt_cap_crgb_sa_crd4;

%macro run_regrpt_crgb;
 
libname _plib_ "&RPTPATH";
 
%local NOBS PROJECT_SET_ORIG HAVEDATA;
 
%let PROJECT_SET_ORIG = %lowcase(&PROJECT_SET);
 
%let NOBS = %attrn(_plib_.CAPITAL_CRGB_SA_CRD4, NOBS);
%checkdata (_plib_,CAPITAL_CRGB_SA_CRD4, );
 
%if &HAVEDATA = NO %then %do;
%print_msg(note,3,1);
%goto EXIT;
%end;
 
%global REPORTS_PROJECT_TYPE;
%let REPORTS_PROJECT_TYPE = CAPITAL_CRGB_SA_CRD4;

%let PROJECT_NAME = &PROJECT_SET._&REPORTS_PROJECT_TYPE;

proc risk noseqcheck ;
 
setpath "&RPTPATH" <;
 
environment open = RD_PROJ.REGRPT;
 
setoptions keeplib;
 
project &PROJECT_NAME
portfolio  = &REPORTS_PROJECT_TYPE
currency   = &REPORT_CCY
crossclass = regrpt_crgb
out        = &PROJECT_NAME
postvarmethod = (PVM_CRSA_ROLLUP)
OUTPATH    = "&RPTPATH"
;
 
runproject &PROJECT_NAME
options = (outall noallscore nomddbs)
report
date    = &RUNDATE;
 
environment save noupdatemetadata;
 
run;
%r0_post_regrpt_01;
%r03_reportmartload_regrpts;
 
/* Create information map for cube if present */
%EXIT:
libname _plib_ clear; 
%let PROJECT_SET=&PROJECT_SET_ORIG;
 
%mend run_regrpt_crgb;
 
%run_regrpt_crgb;
%mend e10_prj_regrpt_cap_crgb_sa_crd4;
