/*****************************************************************************
* Copyright (c) 2013 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME: get_cpty_details_le1_crd4.sas
*
* PURPOSE: Gets Counterparty Details. (LE Template )
*
*   USAGE:
*
*   NOTES:
*
*****************************************************************************/

%macro get_counterparty_details_crd4;
/*checking if it crosses the basic large exposure threshold*/
/**/
/*PROC SQL;*/
/*CREATE TABLE CPTY_DETAILS_TEMP AS*/
/*SELECT **/
/*,SUM(LE_ORIG_EXPOSURE_AMT) as sum_ead_portion, 'regrpt_le1' as INSTTYPE, &TOT_ELIG_CAP as TOT_ELIG_CAP*/
/*FROM _INTDS.CAPITAL_LE1_CRD4;*/
/*where le_counterparty_rk in (&le_cpty_all,&le_cpty_i,&le_cpty_u,&le_cpty_irb)*/
/*GROUP BY LE_COUNTERPARTY_RK*/
/*having sum_ead_portion ge &VALID_LE_EXP;*/
/*quit;*/

/*PROC SQL;*/
/*CREATE TABLE cpty_temp AS*/
/*SELECT *,SUM(LE_ORIG_EXPOSURE_AMT) as sum_ead_portion, 'regrpt_le1' as INSTTYPE, &TOT_ELIG_CAP as TOT_ELIG_CAP*/
/*FROM _INTDS.CAPITAL_LE*/
/*GROUP BY LE_COUNTERPARTY_RK*/
/*having sum_ead_portion ge &VALID_LE_EXP;*/
/*quit;*/

%if %UPCASE(&REGPROJECTNAME)=CAPITAL_LE2_CRD4 %then %do;
PROC SQL;
CREATE TABLE CPTY_DETAILS_TEMP AS
SELECT *,SUM(TOT_ORIG_EXP) as sum_ead_portion, &TOT_ELIG_CAP as TOT_ELIG_CAP
FROM _INTDS.CAPITAL_LE
where le_counterparty_rk in (&le_cpty_all,&le_cpty_i,&le_cpty_u,&le_cpty_irb);
quit;
%end;
%else %if %UPCASE(&REGPROJECTNAME)=CAPITAL_LE3_CRD4 %then %do;
PROC SQL;
CREATE TABLE CPTY_DETAILS_TEMP AS
SELECT *, SUM(TOT_ORIG_EXP) as sum_ead_portion, &TOT_ELIG_CAP as TOT_ELIG_CAP
FROM _INTDS.CAPITAL_LE
where counterparty_group in (select counterparty_group from _intds.groups)
group by LECPTYID;
QUIT;
%end;
%else %if %UPCASE(&REGPROJECTNAME)=CAPITAL_LE4_CRD4 or %UPCASE(&REGPROJECTNAME)= CAPITAL_LE5_CRD4 %then %do;
PROC SQL;
CREATE TABLE CPTY_DETAILS_TEMP AS
SELECT * FROM _INTDS.CASHFLOW_CAPITAL_LE
where le_counterparty_rk in (&le4_cpty_ind_fi,&le4_cpty_ind_ure) or  counterparty_group in (&le4_cpty_groups_fi,&le4_cpty_groups_ure);
QUIT;
%end;

/*keep only those columns that are reqd by LE2,3*/
DATA CPTY_DETAILS_TEMP1 
(KEEP= LECPTYID COUNTERPARTY_GROUP COUNTERPARTY_CD COUNTERPARTY_GROUP_PARENT_FLG CONNECTION_TYPE_CD COUNTERPARTY_NAME
CPTY_TYPE_LE2 UNDERLYING_FLG);
set CPTY_DETAILS_TEMP;
IF COUNTERPARTY_GROUP='' THEN DO;
IF UPCASE("&REGPROJECTNAME") IN ("CAPITAL_LE2_CRD4","ALL") THEN CPTY_TYPE_LE2='1';
END;
ELSE CPTY_TYPE_LE2='2';
IF (NOT MISSING(LE_COUNTERPARTY_RK)) THEN LECPTYID = compress('LE' || input(LE_COUNTERPARTY_RK, $30.));
run;

/*Pick counterparty_cd based on counterparty_group_parent_flg = 1/0*/
PROC SORT DATA = CPTY_DETAILS_TEMP1 OUT=CPTY_SORTED NODUP; 
BY COUNTERPARTY_GROUP DESCENDING COUNTERPARTY_GROUP_PARENT_FLG; 
RUN;

DATA CPTY_SORTED;
SET CPTY_SORTED;
IF COUNTERPARTY_GROUP="" THEN 
DO;
CPTY_CD=COUNTERPARTY_CD;
CPTY_NM=COUNTERPARTY_NAME;
/*LEI=LEGAL_ENTITY_ID;*/
END;
IF COUNTERPARTY_GROUP_PARENT_FLG=1 THEN 
DO;
CPTY_CD=COUNTERPARTY_CD;
CPTY_NM=COUNTERPARTY_GROUP;
/*LEI=LEGAL_ENTITY_ID;*/
END;
RETAIN;
RUN;


/*%if %upcase(&usertype) eq MASTER %then */
/*  %let project_id=%trim(%left(&PROJECT_SET))_%trim(%left(&REGPROJECTNAME))_%trim(%left(&MITIGANTS_ALLOCATION_METHOD))_%trim(%left(&system_id));*/
/*  %else*/
/*  %let project_id=%trim(%left(&PROJECT_SET))_%trim(%left(&REGPROJECTNAME))_%trim(%left(&MITIGANTS_ALLOCATION_METHOD))_%trim(%left(&system_id))_%trim(%left(&username)) ;*/

  data rd_root.counterparty_details;
  set work.CPTY_SORTED;
  output;
  run;

%mend get_counterparty_details_crd4;



 
