/*****************************************************************************
* Copyright (c) 2013 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME: get_cpty_details_le1_crd4.sas
*
* PURPOSE: Gets Counterparty Details. (LE Template )
*
*   USAGE:
*
*   NOTES:
*
*****************************************************************************/

%macro get_cpty_details_le1_crd4;
/*checking if it crosses the basic large exposure threshold*/
/*this will be called in b25 for le1 only*/

PROC SQL;
CREATE TABLE CPTY_DETAILS_TEMP AS
SELECT *,SUM(TOT_ORIG_EXP) as sum_ead_portion, 'regrpt_le1' as INSTTYPE, &TOT_ELIG_CAP as TOT_ELIG_CAP
FROM _INTDS.CAPITAL_LE
where le_counterparty_rk in (&le_cpty_all,&le_cpty_i,&le_cpty_u,&le_cpty_irb);
/*GROUP BY LE_COUNTERPARTY_RK*/
/*having sum_ead_portion ge &VALID_LE_EXP;*/
quit;

proc sort data=work.cpty_details_temp (where=(COUNTERPARTY_GROUP NE "" and COUNTERPARTY_GROUP_PARENT_FLG = 1)) out=_Counterparty_chars_group_le1 
			   (KEEP= LECPTYID COUNTERPARTY_GROUP COUNTERPARTY_CD COUNTERPARTY_GROUP_PARENT_FLG LEGAL_ENTITY_ID 
COUNTERPARTY_COUNTRY SECTOR NACE COUNTERPARTY_SECTOR
FINANCIAL_ENTITY_TYPE_CD CONNECTION_TYPE_CD
COUNTERPARTY_NAME sum_ead_portion UNDERLYING_FLG)
nodupkey;
 by   COUNTERPARTY_GROUP ;
run;



proc sort data=work.cpty_details_temp ( where=(COUNTERPARTY_GROUP EQ "" )) out=_Counterparty_chars_ind_le1
(KEEP= LECPTYID COUNTERPARTY_GROUP COUNTERPARTY_CD COUNTERPARTY_GROUP_PARENT_FLG LEGAL_ENTITY_ID COUNTERPARTY_COUNTRY SECTOR NACE FINANCIAL_ENTITY_TYPE_CD CONNECTION_TYPE_CD
COUNTERPARTY_NAME sum_ead_portion COUNTERPARTY_SECTOR)
nodupkey
;
 by LECPTYID;
run;


DATA _INTDS.CAPITAL_LE1_CRD4;
set _Counterparty_chars_group_le1 _Counterparty_chars_ind_le1;
if COUNTERPARTY_GROUP_PARENT_FLG=1 then do;
COUNTERPARTY_COUNTRY="";
SECTOR =""; 
NACE ="";
end;
else if COUNTERPARTY_GROUP_PARENT_FLG=0 then do;
if upcase(COUNTERPARTY_SECTOR) not in ("OTHER_FIN_CORP","NON_FIN_CORP") then NACE="";
end;
run;

%mend get_cpty_details_le1_crd4;
