/*****************************************************************************
 * Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
 *
 *    NAME: get_shortterm_claim_flg_crd4.sas
 *
 * PURPOSE: Get flags for short-term exposures.
 *
 *   USAGE: %get_shortterm_claim_flg_crd4;
 *          
 *
 *   NOTES: updated 4/18/2013 for CRD-IV
 *                                                                                                                  
 *
 *****************************************************************************/

/*- these flags are used in RW calculation for short-term exposures to institutions and pses  -*/
%macro get_shortterm_claim_flg_crd4;
    SHORT_TERM_ORIG_FLG = .;
    SHORT_TERM_RESIDUAL_FLG = .;
    if ORIGINAL_MATURITY = . then
        SHORT_TERM_CLAIM_FLG = 0;        
    else do;
    /*-   for Institution and PSE counterparty classes -*/        
        if APPROACH = 'STD' and (COUNTERPARTY_CLASS = 'INSTITUTION' or COUNTERPARTY_SUBCLASS = 'PSE') then do ;                                                               
           SHORT_TERM_ORIG_FLG = (ORIGINAL_MATURITY * 12 <= &MAX_ORIG_MAT_IN_MON_SHORT_EXP); /* = 3 months */         
           /*  Created for calculating RW for exposures to institutions : CRR Article 120 */
           if COUNTERPARTY_CLASS = 'INSTITUTION' then 
           SHORT_TERM_RESIDUAL_FLG = (RESIDUAL_MATURITY * 12 <= &MAX_ORIG_MAT_IN_MON_SHORT_EXP);   
        end ;
        
        SHORT_TERM_CLAIM_FLG = (ORIGINAL_MATURITY <= &MAX_ORIG_MAT_IN_YR_SHORT); /* =1 year*/
    end;
%mend get_shortterm_claim_flg_crd4;
