/*****************************************************************************
 * Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
 *
 *    NAME: pm_crm_netting_crd4.sas
 *
 * PURPOSE: Method program code for netting.
 *          
 *
 *   USAGE: %pm_crm_netting_crd4;
 *
 *   NOTES: 
 * 
 *
 *****************************************************************************/
 
/*-   on balance sheet netting of loans and deposits are treated as cash collaterals  -*/
/*    denominated in the same currency: CRR Article 219   -*/
/*-   this means zero risk weight for CRM  -*/
%macro pm_crm_netting_crd4;

    %initialize_regulatory_outvars;

    OUTV_RW_COUNTERPARTY  = 0;
    OUTV_RW_ISSUE  = 0;

    OUTV_LGD_CRM_SEN  = 0;
    OUTV_LGD_CRM_SUB = 0;   
    
    OUTV_FIRM_SIZE = COUNTERPARTY_SIZE;

    _VALUE_ = CRM_VALUE ;
    
%mend pm_crm_netting_crd4;
