/*****************************************************************************
 * Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
 *
 *    NAME: pm_exp_lease_residual_std_crd4.sas
 *
 * PURPOSE: Method program code for lease residual value under STD.
 *
 *   USAGE: %pm_exp_lease_residual_std_crd4;
 *
 *   NOTES: Created 6/5/2013 for CRD-IV.
 *          
 *
 *****************************************************************************/

%macro pm_exp_lease_residual_std_crd4;

/*- initialize outvars -*/
    %initialize_regulatory_outvars;

/*- CRR Article 134(7): If exposure is a residual value of leased assets in which case it shall be calculated as follows -*/ 
    
    OUTV_RW_ISSUE = 1/(max(1,round(RESIDUAL_MATURITY))) * STD_RW_LEASE_RESIDUAL_VALUE;

    _VALUE_ = EXP_VALUE ;
    
%mend pm_exp_lease_residual_std_crd4;
