/*****************************************************************************
 * Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
 *
 *    NAME: pm_exp_mdb_std_crd4.sas
 *
 * PURPOSE: Method program code for exposures to multilateral development banks  
 *          under STD approach in CRD-IV. 
 *         
 *   USAGE: %pm_exp_mdb_std_crd4;
 *
 *           
 *   NOTES: 
 *   4/19/2013: Created for crd4    
 *          
 *****************************************************************************/

%macro pm_exp_mdb_std_crd4;

    /*- initialize outvars -*/
    %initialize_regulatory_outvars;

    /*- by default, get the RW associated with the counterparty -*/
    OUTV_RW_COUNTERPARTY = STD_RW_CPTY;
    
    /* get RW for the list of MDBs having zero risk weight:CRR Article 117(2) */
    if COUNTERPARTY_SUBCLASS eq 'HR_MDB' then do;
       OUTV_RW_ISSUE = STD_RW_HR_MDB;
       if OFF_BALANCE_SHEET_TYPE in ('UNPAID_SEC') and index(upcase(compress(COUNTERPARTY_ID)), compress('EUROPEAN INVESTMENT FUND')) >0 then
          OUTV_RW_ISSUE = STD_RW_UNPAID_CAP_EIF;
    end ;
    
   
    /*- get RW for institution: CRR Article 117(1) -*/ 
    else do;
       %calc_std_rw_inst_crd4 ;
    /*short-term rw does not apply because the short_term_orig_flg and short_term_residual_flg would not turn on for this exposure class*/
    end;       
         
        
    _VALUE_ = EXP_VALUE ;

%mend pm_exp_mdb_std_crd4;
