 /*--------------------------------------------------------------
  * Copyright (C), 2010-2012
  * SAS Institute Inc., Cary, NC, USA.  All Rights Reserved
  * version date: 7 June 2011
  *
  * NAME:      rdcube_generate_im_code.sas
  * PURPOSE:   uses within %rdcube_main to create OLAP cube
  *            information map
  *
  * USAGE:     %rdcube_generate_im_code;
  *
  *-------------------------------------------------------------*/

%macro rdcube_generate_im_code;
   data _NULL_;
         file MyFile mod;
   put ' ';
   put '/* create information map */ ';
   put '%rdcube_verify_object_in_tree(path=' "&out_folder" ',';
   put '                              name=' "&results_name" ',';
   put '                              attrname=PublicType,';
   put '                              attrval=InformationMap.OLAP,';
   put '                              rdcube_outvar=infomapExists);';
   run;
   %rdcube_check_syserr;
   %if &syserr ne 0 %then %return;

   %rdcube_find_olap_host( &olap_schema );

   data _NULL_;
      file MyFile mod;
   put ' ';
   put 'PROC INFOMAPS MAPPATH="' "&out_folder" '"';
   /*put '   METACREDENTIALS= %if %symglobl(METACREDENTIALS) %then %do; YES %end; %else %do; NO %end; ;';*/
   put '   METACREDENTIALS= NO ;';
   put '   %if &infomapExists = 1 %then %do;';
   put '   DELETE INFOMAP "' "&results_name" '";';
   put '   %end;';
   put '   NEW INFOMAP "' "&results_name" '" AUTO_REPLACE=YES';
   put '   DESCRIPTION="' "&description_used" '";';
   put '   INSERT DATASOURCE';
   put '   SASSERVER="&olap_host"';
   put '   CUBE="' "&olap_schema" '"."' "&results_name" '"';
   put '   _ALL_;';
   put '   SAVE;';
   put '   RUN;';

   run;
   %rdcube_check_syserr;
   %if &syserr ne 0 %then %return;


   
%mend rdcube_generate_im_code;

%macro rdcube_find_olap_host( olap_schema );
   data _NULL_;
      file MyFile mod;
   put " ";
   put "/* derive olap_host from olap_schema */";
   put "DATA _NULL_;";
   put "   LENGTH objUri olap_host $ 256;";
   put "   objUri = ' ';";
   put "   olap_host = ' ';";
   put '   rc = METADATA_GETNASN("omsobj:OLAPSchema?@Name=' "'&olap_schema'" '",';
   put '      "DeployedComponents", 1, objUri);';
   put "   IF (rc ne 1) THEN DO;";
   put '      CALL SYMPUT("rskerr", 1);';
   put '      IF TRIM("olap_host") NE "" THEN;';
   put '         CALL SYMPUT("olap_host", "");';
   put "      STOP;";
   put "      END;";
   put '   CALL SYMPUT("rskerr", 0);';
   put '   rc = METADATA_GETATTR(objuri, "Name", olap_host);';
   put '   CALL SYMPUT("olap_host",trim(olap_host));';
   put "   RUN;";
   %RDCUBE_SET_RSKERR;
   %RDCUBE_CHECK_RSKERR1( 'rdcube_4', '&olap_schema' );
   run;
   %rdcube_check_syserr;
   %if &syserr ne 0 %then %return;
%mend rdcube_find_olap_host;
