 /*--------------------------------------------------------------
  * Copyright (C), 2010-2012
  * SAS Institute Inc., Cary, NC, USA.  All Rights Reserved
  * version date: 19 October 2010
  *
  * NAME:      rdcube_get_tree_uri.sas
  * PURPOSE:   finds uri of tree
  *
  * USAGE:     %rdcube_get_tree_uri( path=, outvar=folderuri );
  *
  * PARAMETERS:
  *     path=      - path of tree
  *     folderuri= - uri of tree
  *
  *-------------------------------------------------------------*/

%macro rdcube_get_tree_uri(path=, rdcube_outvar=folderuri);
  /* find the root folder */
  %put '1 ' &rdcube_outvar;

data _null_;
   length uri $256 objName $256 objUri $256;
   %let root = %scan(&path,1,/);
   n = 1;
   objectFound = 0;
   numObjs = METADATA_GETNASN("omsobj:SoftwareComponent?@Name='BIP Service'", "SoftwareTrees", 1, uri);
   do until(n > numObjs | objectFound) ;
       rc = metadata_getattr(uri, "Name", objName);
      if (objName = "&root") then do;
        objectFound = 1;
       objUri = uri;
      end; 
      else do;
        n = n+1;
        rc = metadata_getnasn("omsobj:SoftwareComponent?@Name='BIP Service'", "SoftwareTrees", n, uri);
      end;
   end;
  
   %do i=2 %to 999;
    n = 1;
   objectFound = 0;
    %let token = %scan( &path, &i, /);
   %if &token ne %then %do;
        numObjs = metadata_getnasn(objUri, "SubTrees", 1, uri);
          do until(n > numObjs | objectFound) ;
              rc = metadata_getattr(uri, "Name", objName);
             if (objName = "&token") then do;
                objectFound = 1;
               objUri = uri;
              end; 
              else do;
               n = n+1;
               rc = metadata_getnasn(objUri, "SubTrees", n, uri);
              end;
           end;
   %end;
   %else %do ;
     %let i = 999;
   %end;
   
 %end;
 %put '2 ' &rdcube_outvar;
 call symput("&rdcube_outvar", objUri);
  %put '3 ' &rdcube_outvar;

run;
%mend rdcube_get_tree_uri;
