 /*--------------------------------------------------------------
  * Copyright (C), 2010-2012
  * SAS Institute Inc., Cary, NC, USA.  All Rights Reserved
  * version date: 19 October 2010
  *
  * NAME:      rdcube_verify_object_in_tree.sas
  * PURPOSE:   verifies existence of specified object in tree
  *
  * USAGE:     %rdcube_verify_object_in_tree( path=, name=, 
  *                                           attrname=, attrval=, 
  *                                           rdcube_outvar=intree );
  *
  * PARAMETERS:
  *     path=         - path to find object in tree
  *     name=         - name of object to find in tree
  *     attrname=     - name of attribute/identifier of object to find in tree
  *     attrval=      - value of attribute/identifier of object to find in tree
  *     rdcube_outvar=intree - macro variable to set, holding the uri of found object
  *
  *-------------------------------------------------------------*/

%macro rdcube_verify_object_in_tree(path=, name=, attrname=, attrval=, rdcube_outvar=intree);
   %local treeuri;
   %local objuri;

   %rdcube_get_tree_uri(path=&path, rdcube_outvar=treeuri);
   %rdcube_get_object_in_tree(treeuri=&treeuri,objname=&name, attrname=&attrname, attrval=&attrval,rdcube_outvar=objuri);
	
   %if &objuri ne %then %do;
      %let &rdcube_outvar=1;
   %end;
   %else %do;
      %let &rdcube_outvar=0;
   %end;
%mend rdcube_verify_object_in_tree;
