/*+---------------------------------------------------------------------------- */
/*|                Copyright (c) 2012 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.   */
/*|                SAS Campus Drive, Cary, NC 27513 USA    */
/*|                ---All rights reserved     */
/*+-----------------------------------------------------------------------------*/
/* Modified for V48         */
/* Regulatory Reporting IRB       */

 
/* Create Data for Report */

%macro regrpt_capital_crirba_crd4;
%regrpt_d0_capital_crirbf_crd4;
 
 
proc format;
value $exp_type (default=256)
			      'NETTING'   =   "   &NETTING_CRRPT"
            'OFF_BALANCE'  =   "   &IRB_L_30"
            'REPOS'     =   "       &IRB_L_40"
            'DERIVATIVES'   =   "   &IRB_L_50"
            'ON_BALANCE'    =   "   &IRB_L_20"
            'UNDEFINED'     =       "       &MISSING"   
            'DILUTION_RISK' =   "   &DILUTION_RSK"
'SL_RW_0_0'    =       "Risk Weight : 0%"
'SL_RW_50_50'    =      "50%"
'SL_CAT_1'    =      "&IRB_L_120"
'SL_RW_70_70'    =       "70%"
'SL_RW_90_90'    =      "90%"
'SL_RW_115_115'    =       "115%"
'SL_RW_250_250'    =      "250%";  

/*            
'SL_RW_0_0'    =       "&SL_RW_0_50"
'SL_RW_50_50'    =      "&SL_RW_50_70"
'SL_RW_70_70'    =       "&SL_RW_70_90"
'SL_RW_90_90'    =      "&SL_RW_90_115"
'SL_RW_115_115'    =       "&SL_RW_115_250"
'SL_RW_250_250'    =      "&SL_RW_250_1250";  
*/

run;

**********************************************************;
* Create Local macros for CRSA Reporting                 *;
**********************************************************;
%let style_type=%str(style=Data[Tagattr='format:#,##0.00' ]);  

 
/* Creates basic  template report */
%macro report_page (dsn);
 
proc report data=&dsn nowd missing LS=160 PS=50 SPLIT="*" contents=""
style(column)={ bordercolor=#FAF8ED cellspacing=0}
style(header)={cellheight=0  cellspacing=0 background=#CED3D6 font_weight = Bold};
 
column  
     (CLASS_CR_IRBF)
     ("&IRB_INT_RATING_SYSTEM"  outv_pd_eff)
     ("&orig_exp_preccf" outv_exp_pre_ccf_pre_crm (outv_large_fin_org_exp_amt)
     )   
     /*("ead_from_ccr" outv_ead_ccr)*/
     ("&credit_risk_mit_tech" ("&irb_unfunded_credit_protection"
      _guar_unfund_nlgd _crd_deriv_unfund_nlgd)
     (_fund_cred_protect_nlgd )
    ("&sub_exposure_crm" outv_outflow_irb_amt outv_inflow_irb_amt))
    ("&irb_exp_post_crm_preccf" outv_exp_pre_ccf_after_crm _off_bal_exp_pre_ccf_crm
    )
    ("&irb_exp_details" OUTV_EAD _off_bal_ead outv_exp_of_which_ccr outv_large_fin_exposure_val_amt  )
("&crm_lgd_est_no_dd"
    ("&IRB_OWN_EST_LGD_UNFND" _guar_unfund_lgd _crd_deriv_unfund_lgd)
    ("&funded_cp"
    _fund_cred_protect_lgd
    outv_elig_fin_collateral_amt
    ("&other_elig_clltrl" outv_clltrl_real_estate_amt outv_clltrl_other_physical_amt
    outv_clltrl_receivable_amt)))
("&subject_dd" _unfund_cred_protect_lgd_dd)
    outv_lgd_eff
    outv_wa_lgd_large_fin_amt
    outv_mat_eff
    rwa_pre_sme_amt
   ("&IRB_RWA_AFT_SME_AMT" outv_rwa
    outv_rwa_large_fin_entity_amt)
    /*outv_capital*/
    
    ("&IRB_MEMORANDUM" outv_el_amt outv_value_adj_amt outv_obligor_nbr)
    
 
;
        
    define CLASS_CR_IRBF                /display format=$exp_type.  style=[font_weight=bold  ] "" ;
    define outv_pd_eff              /display format=NLNUM6.3    ""  "&_obligor_pool_grade"      ;
    define outv_exp_pre_ccf_pre_crm         /display &style_type.       ""              ;  
    define outv_large_fin_org_exp_amt      /display &style_type.    "&irb_large_fin_org_exposure"        ;    
    /*define outv_ead_ccr         /display &style_type.       ""      ; */ 
    define  _guar_unfund_nlgd           /display &style_type.       "(-) &GUARANTEES"           ;
    define  _crd_deriv_unfund_nlgd          /display &style_type.       "(-) &crd_deriv"            ;
    define _fund_cred_protect_nlgd                  /display &style_type.       "(-) &funded_credit_proc"       ;;
    define outv_outflow_irb_amt         /display &style_type.       "&total_outflow"        ;   
    define outv_inflow_irb_amt          /display &style_type.       "&total_inflow"         ;
    define outv_ead                 /display &style_type.       ""              ;   
    define outv_exp_pre_ccf_after_crm       /display &style_type.       ""              ;
    define _off_bal_ead                 /display &style_type.       "&_off_bal_ead"         ;
    define outv_exp_of_which_ccr        /display &style_type.       "&irb_exp_of_which_ccr"         ;
    define outv_large_fin_exposure_val_amt       /display &style_type.       "&irb_large_fin_exposure_val"         ;
    define _off_bal_exp_pre_ccf_crm         /display &style_type.       "&_off_bal_exp_pre_ccf_crm" ;
    define  _guar_unfund_lgd            /display &style_type.       "&GUARANTEES"           ;
    define  _crd_deriv_unfund_lgd           /display &style_type.       "&crd_deriv"            ;   
    DEFINE  _fund_cred_protect_lgd          /display &style_type.       "&IRB_FUND_C_PROTECT_LGD"       ;
    define outv_elig_fin_collateral_amt     /display &style_type.       "&irb_elig_fin_collateral_amt" ;
    define outv_clltrl_real_estate_amt      /display &style_type.       "&outv_clltrl_real_estate_amt"  ;
    define outv_clltrl_other_physical_amt       /display &style_type.       "&outv_clltrl_other_physical_amt";
    define outv_clltrl_receivable_amt       /display &style_type.       "&outv_clltrl_reveivable_amt"   ;
    define outv_lgd_eff             /display &style_type.       "&IRB_outv_lgd_eff"         ;
    define outv_wa_lgd_large_fin_amt  /display &style_type.       "&irb_rwa_lgd_large_fin"         ;
    define _unfund_cred_protect_lgd_dd        /display &style_type.       "&irb_unfunded_credit_protection"   ;
    define outv_mat_eff         /display &style_type.       "&irb_outv_mat_eff"    ;
    define rwa_pre_sme_amt                 /display &style_type.       "&IRB_RWA_PRE_SME_AMT"         ;    
    define outv_rwa                  /display &style_type.       " " /* "&IRB_RWA_AFT_SME_AMT" */        ;
    define outv_rwa_large_fin_entity_amt  /display &style_type.       "&irb_rwa_large_fin_entity"         ;
    define outv_el_amt              /display &style_type.       "&irb_el_amt"          ;
    define outv_value_adj_amt           /display &style_type.       "&irb_value_adj_amt"   ;
    define outv_obligor_nbr             /display &style_type.       "&IRB_OUTV_OBLIGOR_NBR"     ;
   /*define outv_capital             /display &style_type.       "&outv_capital"     ;*/
 
    compute class_cr_irbf;
       count+1;
       if mod(count,2) then do;
         call define(_row_,"Style", "Style=[background=#E6EDFF]");
       end;
    endcomp;
 
run;
 
 
%mend report_page;
 
%macro generate_report;
 
%if NOT %sysfunc(exist(work.current_regulatory)) or NOT %sysfunc(exist(work.&regprojectname._1))
or %upcase(&SYSTEM_FATAL_ERROR) = %upcase (Y) %then %do;
%print_msg(warning,3,10);
%print_msg(warning,3,15);
%regulatory_reportnopage();
%return;
%goto FINAL;
%end;
 
/* Get number of report pages */
%let pages=%attrn(report_pages,NOBS);

%do this_page=1 %to &PAGES ;
 
/*Change to &pages */
/*If data is not available for the report page then do no run report content */
%if NOT %sysfunc(exist(work.&regprojectname._&this_page)) %then %do;
%print_msg(warning,3,19);
%print_msg(note,3,20);
%regulatory_reportnopage();
%goto NOPAGE;
%end;
 
   %if &APPLY_CCF_AFTER_CRM EQ NO %then %do;
   
       %let ccf_crm_msg=%print_msg(,3,108,1); 
      footnote "&ccf_crm_msg";
  %end;
 
/* Displays the titles for the cross-classification variables */
%if %upcase(&REPORT_TYPE)=%upcase(XLS) %then %do;
	/*
	data _null_;
		ID = open("report_pages");
		Var_name = upcase(varname(ID,2));
		RC = close(ID);
		call symputx("class_sa_lev1",var_name);
	run;
	*/ 
   data _null_;
    set report_pages(firstobs=&this_page obs=&this_page);
	/* call symputx("sheet_nm",put(&class_sa_lev1,$aggregate.));*/ 
	call symputx("sheet_nm",&this_page);
	
   run;

   ods tagsets.ExcelXP_Mod 
 		options(
		sheet_name="&sheet_nm"
		sheet_interval='none' autofit_height="yes");
		%_Report_Title(REPORT_TITLE_CD=rpt_cd2,REPORT_TITLE=rpt_title1);
   ods tagsets.ExcelXP_Mod 
 		options(
		autofit_height="NO");

%end;

%regulatory_reportheaders_IRB(work.&regprojectname._&this_page);
%if "&delete_flag" EQ "YES" %then %do;

data work.&regprojectname._&this_page.;
 set work.&regprojectname._&this_page.;
 if _n_ ne 1 then do;
	if rank not in (181, 200) then do;
	 call missing(of rank -- _unfund_cred_protect_lgd_dd);
	end;
 end;
	
%end;
 
%report_page (work.&regprojectname._&this_page.(where=(rank not in (181, 200))));
/* for obligor
data _order_check_&this_page. ; 
set  work.&regprojectname._&this_page.(where=(rank in (200))) ;
if  not missing (_order_) ; 
run;

 %if (%attrn(_order_check_&this_page.,nobs) > 0 ) %then %do ;
%if %upcase(&REPORT_TYPE)=%upcase(XLS) %then %do;

	  	%_Report_Title(REPORT_TITLE_CD=rpt_cd2,REPORT_TITLE=rpt_title2);
%end;
      %report_page (work.&regprojectname._&this_page.(where=(rank in (181,200))));
    
  %end; 
for obligor */ 
/* subroutine for no data available for report page */
%NOPAGE:
 
%end;
%FINAL:
footnote ;



%mend generate_report; /* end reportbody macro */
 
/*-------------------------------------------------------------*;
 Generate Report for Obligor Grade Information.
 *-------------------------------------------------------------*/

%generate_report;

%regulatory_irb_obligors_crd4;
 
 
 
 
 
 
%mend regrpt_capital_crirba_crd4;
