/*****************************************************************************
* Copyright (c) 2013 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME:regrpt_capital_le1.sas
*
* PURPOSE: Creates report for the Large Exposures report
*
*
*   USAGE: 
*
*   NOTES: Created for v4.8
*   Macro Options:
*****************************************************************************/
 
%macro regrpt_capital_le1_crd4;

/*%regrpt_d0_capital_le1_crd4;*/
 
/* Creates basic  template report */
%macro report_page (dsn);

%let style_type=%str(style=Data[Tagattr='format:#,##0.00' ]);  

proc report data=&dsn nowd missing LS=160 PS=50 /*SPLIT="*"*/ contents=""
style(column)={ /*bordercolor=#FAF8ED*/ cellspacing=0}
style(header)={background=#CED3D6 cellheight=0  cellspacing=0 fontweight=bold};


column  
 ("COUNTERPARTY IDENTIFICATION"           /*B1 Start*/
			COUNTERPARTY_CD         /* COL 010  */
			COUNTERPARTY_NAME       /* COL 020  */
			LEGAL_ENTITY_ID             /* COL 030  */
      		COUNTERPARTY_COUNTRY        /*COL 040 */
			COUNTERPARTY_SECTOR     /*COL 050*/
			NACE            /* COL 060  */
			FINANCIAL_ENTITY_TYPE_CD    /* COL 070  */ /*New in LE1 SEP templates*/
  )                                        /*B1 Close*/
 ;


define       COUNTERPARTY_CD        /display      " "              "Code";
define       COUNTERPARTY_NAME           /display     " "              "Name";
define       LEGAL_ENTITY_ID        /display     " "              "LEI code";
define       COUNTERPARTY_COUNTRY        /display      " "              "Residence of the counterparty";
define       COUNTERPARTY_SECTOR        /display   style(column)={tagattr='000'}  " "              "Sector of the counterparty";
define       NACE         /display      " "              "NACE code";
define       FINANCIAL_ENTITY_TYPE_CD         /display      " "              "Type of counterparty";

     
    compute COUNTERPARTY_CD;
       count+1;
       if mod(count,2) then do;
         call define(_row_,"Style", "Style=[background=#ffffff]");
       end;
    endcomp;

run;

 
 
%mend report_page;
 

 
%macro generate_report;

%let RPTPATH = %sysget(CRISKMRES)&pathsep.&project_set;
libname _intds "&RPTPATH" ;

%if NOT %sysfunc(exist(_INTDS.CAPITAL_LE1_CRD4)) /*or NOT %sysfunc(exist(work._LE1_GRP_IND_REPORT))*/
or %upcase(&SYSTEM_FATAL_ERROR) = %upcase (Y) %then %do;
%print_msg(warning,3,10);
%print_msg(warning,3,15);
%regulatory_reportnopage();
/*%return;*/
%goto FINAL;
%end;
 
/* Get number of report pages */
/*%let pages=%attrn(report_pages,NOBS);
 
%do this_page=1 %to &PAGES ;
*/ 
/*Change to &pages */
/*If data is not available for the report page then do no run report content */
%if NOT %sysfunc(exist(_INTDS.CAPITAL_LE1_CRD4)) %then %do;
%print_msg(warning,3,19);
%print_msg(note,3,20);
%regulatory_reportnopage();
%goto NOPAGE;
%end;

 
/* Displays the titles for the cross-classification variables */

/*%regulatory_reportheaders(work._LE1_GRP_IND_REPORT);*/
%if &report_type=XLS %then %do;

   ods tagsets.ExcelXP_Mod 
 		options(
		sheet_name="&rpt_cd."
		sheet_interval='none' autofit_height="yes");
		%_Report_Title(REPORT_TITLE_CD=rpt_cd2,REPORT_TITLE=rpt_title1);
   ods tagsets.ExcelXP_Mod 
 		options(
		autofit_height="NO"); 
%end;

%report_page (_INTDS.CAPITAL_LE1_CRD4);
 
/* subroutine for no data available for report page */
%NOPAGE:
 

 
%FINAL:
footnote ;
 
%mend generate_report; /* end reportbody macro */
 
%generate_report;
 

 
%mend regrpt_capital_le1_crd4;
