/*****************************************************************************
* Copyright (c) 2013 by SAS Institute Inc., Cary, NC, USA. All Rights Reserved.
*
*    NAME:regrpt_d0_capital_le3_crd4.sas
*
* PURPOSE: Creates data for the LE 3 report
*
*
*   USAGE:
*
*   NOTES: Modified for V4.8
*   Macro Options:
*****************************************************************************/
%macro regrpt_d0_capital_le3_crd4;

%macro createRegulatoryView (fact_table=);
/*---------------------------------------------------------------------------
* Step 1.
* Check for data in the repository and create a dataset for the project
* the dataset is work.current_regulatory
* -------------------------------------------------------------------------*/
%if %upcase(&usertype) eq MASTER %then
%let projectview=%trim(%left(&PROJECT_SET))_%trim(%left(&REGPROJECTNAME))_%trim(%left(&MITIGANTS_ALLOCATION_METHOD))_%trim(%left(&system_id));
%else
%let projectview=%trim(%left(&PROJECT_SET))_%trim(%left(&REGPROJECTNAME))_%trim(%left(&MITIGANTS_ALLOCATION_METHOD))_%trim(%left(&system_id))_%trim(%left(&username));
%put projectview=&projectview;
/* Create SQL views into datamart with no history */
%create_risk_repository_views
(Project_name=&projectview,Fact_table=&fact_table,Current=YES,Year=NO,Allhistory=NO, where=NONE, obs=0);
 
%mend createRegulatoryView;

/* Create views of fact table with cross-class macro names */
%createRegulatoryView (fact_table=Regulatory);


/*proc sort data=current_regulatory ( where=(upcase(&rptvar1.) NE "MISSING" )) out=_LE3_GROUP;*/
/* by &rptvar2;*/
/*run;*/

proc sort data=current_regulatory ( where=(upcase(&rptvar1.) NOT IN ("MISSING","+") and &rptvar2. NE "+" )) out=_LE3_GROUP;
 by &rptvar2;
run;

/*
proc sort data=current_regulatory ( where=(upcase(&rptvar1.) EQ "MISSING" )) out=_LE1_INDIVIDUAL;
 by &rptvar1;
run;

data _LE1_GRP_IND;
 set _LE1_INDIVIDUAL _LE1_GROUP;
 by &rptvar1;
run;
proc sort data=_LE1_GRP_IND;
 by &rptvar2;
run;
*/
proc sort data=rd_root.counterparty_details(rename=(LECPTYID=&rptvar2)) out=_Counterparty_chars
			   (Keep=&rptvar2 COUNTERPARTY_GROUP CPTY_CD UNDERLYING_FLG	 CPTY_NM CONNECTION_TYPE_CD
				)nodupkey;
/*This code should be un-commented */
 by /*project_id*/
	&rptvar2 
 	CPTY_CD
	UNDERLYING_FLG
/*	NACE */
/*	CPTY_TYPE_LE3*/
	CPTY_NM   
	/*CPTY_RES*/
	/*CPTY_SECTOR*/
	/*LEI*/ 
CONNECTION_TYPE_CD
;
run;
data _LE_3_GRP_REPORT;
 merge _LE3_GROUP(in=a) _Counterparty_chars(in=b);
 by &rptvar2;
 if a;
run;

data _LE_3_GRP_REPORT;
length OUTV_NOT_POPULATED 8.;
 set  _LE_3_GRP_REPORT ;
 OUTV_NOT_POPULATED=.;
run;

%mend regrpt_d0_capital_le3_crd4;
